//=============================================================================
// ASC Ath Server Controller
// Version 7
// October 2004
// By 'ATHoS' Mickal DEHEZ && Cedric MEGNAT
//=============================================================================
//=============================================================================
// asc_tkprotector.
//=============================================================================
class asc_tkprotector expands asc_root;
struct tked
{
	var String me;
	var String him;
	var int etat;
	var bool bwarned;
};
var tked tkeds[64];
var bool bFirstTick;
function PostBeginPlay(){
}
function PreBeginPlay()
{
	Level.Game.RegisterDamageMutator(Self);
	SetTimer(1,true);
}
event timer()
{
	local int i;
	if ( !bFirstTick ) {
		SendToListStart();
		bFirstTick = True;
	}
	for(i=0;i<64;i++){
		if(tkeds[i].me!="")
			tkeds[i].etat--;
	}
	for(i=0;i<64;i++){
		if(tkeds[i].me!="")
			if(tkeds[i].etat==0)
				tkeds[i].me="";
	}	
}
function int tked_etat(Pawn P)
{
	local int i;
	for(i=0;i<64;i++)
		if(tkeds[i].me==P.PlayerReplicationInfo.PlayerName)
			return tkeds[i].etat;
	return 0;
}
function bool PreventDeath(Pawn Killed, Pawn Killer, name damageType, vector HitLocation)
{
	if(DamageType == 'Suicided'){
		return false;		
	}
	if( Killed.IsA('TournamentPlayer') ){	
		if(tked_etat(Killed) > 0 && Killer.IsA('PlayerPawn'))
			if( Killer.PlayerReplicationInfo.Team != Killed.PlayerReplicationInfo.Team)
				return false;
		if(tked_etat(Killed) > 0 && !tkeds[Killed.PlayerReplicationInfo.PlayerID].bwarned){
	
			br(tkeds[Killed.PlayerReplicationInfo.PlayerID].him@"tried to team-kill"@
								tkeds[Killed.PlayerReplicationInfo.PlayerID].me@"(protected)",6);
			if( Killed.Health < 10 )
				Killed.Health=100;
			tkeds[Killed.PlayerReplicationInfo.PlayerID].bwarned=true;
			return true;		
		}
	}
	if ( NextMutator != None && NextMutator.PreventDeath(Killed, Killer, damageType, HitLocation) )
		return true;
	return false;
}
function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
	if ( Victim.bIsPlayer
			&& Victim.IsA('TournamentPlayer')
			&& InstigatedBy != None 
			&& InstigatedBy.bIsPlayer
			&& InstigatedBy.IsA('TournamentPlayer')
			&& Victim != InstigatedBy 
		&& VSize(Momentum) > 0 )
	{
		if(tked_etat(Victim) > 0){	
			if(!tkeds[Victim.PlayerReplicationInfo.PlayerID].bwarned && ActualDamage > 32 ){
				br(tkeds[Victim.PlayerReplicationInfo.PlayerID].him@"tried to team-kill"@
							tkeds[Victim.PlayerReplicationInfo.PlayerID].me@"(protected)",5);
				tkeds[Victim.PlayerReplicationInfo.PlayerID].bwarned=true;
				ActualDamage=0;
			}	
		}	
		else if(Victim != InstigatedBy && Victim.PlayerReplicationInfo.Team == InstigatedBy.PlayerReplicationInfo.Team){
			tkeds[Victim.PlayerReplicationInfo.PlayerID].me=Victim.PlayerReplicationInfo.PlayerName;	
			tkeds[Victim.PlayerReplicationInfo.PlayerID].him=InstigatedBy.PlayerReplicationInfo.PlayerName;
			tkeds[Victim.PlayerReplicationInfo.PlayerID].etat=4;
			ActualDamage=0;
		}
	}
	if ( NextDamageMutator != None )
		NextDamageMutator.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
}
function SendToListStart()
{
	local Mutator M, PrevMutator;
	
	For (M = Level.Game.BaseMutator; M != None; M = M.NextMutator) {
		if ( M == Self && PrevMutator == None )
			break;
		else if ( M == Self ) {
			PrevMutator.NextMutator = NextMutator;
			NextMutator = Level.Game.BaseMutator.NextMutator;
			Level.Game.BaseMutator.NextMutator = Self;
			break;
		}
	}
}
